"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli_1 = require("./callbacks/cli");
var Runner = (function () {
    function Runner(callbacks) {
        this._run = null;
        this._startTime = null;
        this._stepIndex = 0;
        this._callbacks = callbacks || {};
    }
    Runner.prototype.step = function (step) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.beforeStep()];
                    case 1:
                        _a.sent();
                        return [4, this.runStep(step)];
                    case 2:
                        _a.sent();
                        return [4, this.afterStep()];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Runner.prototype.run = function (job) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, step;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, this.beforeRun(job)];
                    case 1:
                        _b.sent();
                        _i = 0, _a = job.steps;
                        _b.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3, 5];
                        step = _a[_i];
                        return [4, this.step(step)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        _i++;
                        return [3, 2];
                    case 5: return [4, this.afterRun(job)];
                    case 6:
                        _b.sent();
                        return [2];
                }
            });
        });
    };
    Runner.prototype.getRun = function () {
        if (!this._run) {
            throw "Run not created yet";
        }
        return this._run;
    };
    Runner.prototype.beforeRun = function (job) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._run = cli_1.createRunFromJob(job);
                this._run.status = "runs";
                return [2];
            });
        });
    };
    Runner.prototype.beforeStep = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this._run) {
                    this._run.steps[this._stepIndex].status = "runs";
                }
                return [2, runCallbacks(this, this._callbacks.beforeStep)];
            });
        });
    };
    Runner.prototype.afterStep = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this._run) {
                    this._run.steps[this._stepIndex].status = "pass";
                }
                this._stepIndex += 1;
                return [2, runCallbacks(this, this._callbacks.afterStep)];
            });
        });
    };
    Runner.prototype.afterRun = function (job) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._run.status = "pass";
                return [2, runCallbacks(this, this._callbacks.afterRun)];
            });
        });
    };
    Runner.prototype.runStep = function (step) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2];
            });
        });
    };
    return Runner;
}());
exports.Runner = Runner;
var runCallbacks = function (runner, callbacks) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, Promise.all((callbacks || []).map(function (callback) { return callback(runner); }))];
            case 1:
                _a.sent();
                return [2];
        }
    });
}); };
//# sourceMappingURL=Runner.js.map