"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Runner_1 = require("./Runner");
var job_1 = require("./fixtures/job");
var step = job_1.loginJob.steps[0];
test("step callbacks called at correct time", function () { return __awaiter(void 0, void 0, void 0, function () {
    var callback, callback2, callback3, callback4, runner;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                callback = jest.fn();
                callback2 = jest.fn();
                callback3 = jest.fn();
                callback4 = jest.fn();
                runner = new Runner_1.Runner({
                    beforeStep: [callback, callback2],
                    afterStep: [callback3],
                    afterRun: [callback4]
                });
                expect(callback).not.toBeCalled();
                expect(callback2).not.toBeCalled();
                expect(callback3).not.toBeCalled();
                expect(callback4).not.toBeCalled();
                return [4, runner.step(step)];
            case 1:
                _a.sent();
                expect(callback).toBeCalledTimes(1);
                expect(callback).toBeCalledWith(runner);
                expect(callback2).toBeCalledTimes(1);
                expect(callback2).toBeCalledWith(runner);
                expect(callback3).toBeCalledTimes(1);
                expect(callback3).toBeCalledWith(runner);
                expect(callback4).not.toBeCalled();
                return [4, runner.step(step)];
            case 2:
                _a.sent();
                expect(callback).toBeCalledTimes(2);
                expect(callback).toBeCalledWith(runner);
                expect(callback2).toBeCalledTimes(2);
                expect(callback2).toBeCalledWith(runner);
                expect(callback3).toBeCalledTimes(2);
                expect(callback3).toBeCalledWith(runner);
                expect(callback4).not.toBeCalled();
                return [2];
        }
    });
}); });
test("run callbacks called at correct time", function () { return __awaiter(void 0, void 0, void 0, function () {
    var callback, callback2, callback3, callback4, runner;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                callback = jest.fn();
                callback2 = jest.fn();
                callback3 = jest.fn();
                callback4 = jest.fn();
                runner = new Runner_1.Runner({
                    beforeStep: [callback, callback2],
                    afterStep: [callback3],
                    afterRun: [callback4]
                });
                expect(callback).not.toBeCalled();
                expect(callback2).not.toBeCalled();
                expect(callback3).not.toBeCalled();
                expect(callback4).not.toBeCalled();
                return [4, runner.run({ name: "Log in", steps: [step, step], url: "url" })];
            case 1:
                _a.sent();
                expect(callback).toBeCalledTimes(2);
                expect(callback).toBeCalledWith(runner);
                expect(callback2).toBeCalledTimes(2);
                expect(callback2).toBeCalledWith(runner);
                expect(callback3).toBeCalledTimes(2);
                expect(callback3).toBeCalledWith(runner);
                expect(callback4).toBeCalledTimes(1);
                expect(callback4).toBeCalledWith(runner);
                return [2];
        }
    });
}); });
test("getRun throws error if run not created", function () {
    var runner = new Runner_1.Runner();
    expect(function () { return runner.getRun(); }).toThrowError();
});
test("runs property is created after job is run", function () { return __awaiter(void 0, void 0, void 0, function () {
    var runner, run;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                runner = new Runner_1.Runner();
                return [4, runner.run({ name: "Log in", steps: [step, step], url: "url" })];
            case 1:
                _a.sent();
                run = runner.getRun();
                expect(run).toMatchObject({
                    name: "Log in",
                    status: "pass"
                });
                expect(run.startTime).toBeTruthy();
                return [2];
        }
    });
}); });
//# sourceMappingURL=Runner.test.js.map