"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_extra_1 = __importDefault(require("fs-extra"));
var puppeteer_1 = __importDefault(require("puppeteer"));
var utils_1 = require("../utils");
var webBundle = fs_extra_1.default.readFileSync("dist/qawolf.web.js", "utf8");
var Browser = (function () {
    function Browser(browser) {
        this._currentPageIndex = 0;
        this._pages = [];
        this._browser = browser;
    }
    Browser.create = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var puppeteerBrowser, browser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, puppeteer_1.default.launch({
                            args: ["–no-sandbox", "--disable-setuid-sandbox"],
                            headless: false,
                            defaultViewport: {
                                height: 1080,
                                width: 1920
                            }
                        })];
                    case 1:
                        puppeteerBrowser = _a.sent();
                        browser = new Browser(puppeteerBrowser);
                        return [4, browser.wrapPages()];
                    case 2:
                        _a.sent();
                        if (!url) return [3, 4];
                        return [4, browser.goto(url)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2, browser];
                }
            });
        });
    };
    Browser.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._browser.close()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Browser.prototype.currentPage = function () {
        return this.page(this._currentPageIndex);
    };
    Browser.prototype.page = function (index, timeoutMs) {
        if (index === void 0) { index = 0; }
        if (timeoutMs === void 0) { timeoutMs = 5000; }
        return __awaiter(this, void 0, void 0, function () {
            var i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < timeoutMs / 100 && index >= this._pages.length)) return [3, 4];
                        return [4, utils_1.sleep(100)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3, 1];
                    case 4:
                        if (index >= this._pages.length) {
                            throw new Error("waiting for page " + index + " timed out");
                        }
                        this._currentPageIndex = index;
                        return [2, this._pages[index]];
                }
            });
        });
    };
    Browser.prototype.runStep = function (step) {
        return __awaiter(this, void 0, void 0, function () {
            var page, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.page(step.pageId)];
                    case 1:
                        page = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4, page.evaluate(function (step) {
                                var qawolf = window.qawolf;
                                return qawolf.runStep(step);
                            }, step)];
                    case 3:
                        _a.sent();
                        return [3, 5];
                    case 4:
                        error_1 = _a.sent();
                        if (error_1.message ===
                            "Execution context was destroyed, most likely because of a navigation.") {
                            return [2, this.runStep(step)];
                        }
                        throw error_1;
                    case 5: return [2];
                }
            });
        });
    };
    Browser.prototype.goto = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.currentPage()];
                    case 1:
                        page = _a.sent();
                        return [4, page.goto(url)];
                    case 2:
                        _a.sent();
                        return [2, page];
                }
            });
        });
    };
    Browser.prototype.wrapPages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var pages, _i, pages_1, page;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._browser.pages()];
                    case 1:
                        pages = _a.sent();
                        _i = 0, pages_1 = pages;
                        _a.label = 2;
                    case 2:
                        if (!(_i < pages_1.length)) return [3, 5];
                        page = pages_1[_i];
                        return [4, Promise.all([
                                page.evaluate(webBundle),
                                page.evaluateOnNewDocument(webBundle)
                            ])];
                    case 3:
                        _a.sent();
                        this._pages.push(page);
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3, 2];
                    case 5:
                        this._browser.on("targetcreated", function (target) { return __awaiter(_this, void 0, void 0, function () {
                            var page;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, target.page()];
                                    case 1:
                                        page = _a.sent();
                                        if (!page) return [3, 3];
                                        return [4, Promise.all([
                                                page.evaluate(webBundle),
                                                page.evaluateOnNewDocument(webBundle)
                                            ])];
                                    case 2:
                                        _a.sent();
                                        this._pages.push(page);
                                        _a.label = 3;
                                    case 3: return [2];
                                }
                            });
                        }); });
                        return [2];
                }
            });
        });
    };
    return Browser;
}());
exports.Browser = Browser;
exports.$xText = function (page, xpath) { return __awaiter(void 0, void 0, void 0, function () {
    var elements, text;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.$x(xpath)];
            case 1:
                elements = _a.sent();
                return [4, page.evaluate(function (element) { return element.textContent; }, elements[0])];
            case 2:
                text = _a.sent();
                return [2, text];
        }
    });
}); };
//# sourceMappingURL=Browser.js.map