"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Runs_1 = __importDefault(require("../cli/Runs"));
exports.buildRuns = function (run) {
    var summary = run.status === "pass" || run.status === "fail"
        ? {
            fail: run.status === "fail" ? 1 : 0,
            pass: run.status === "pass" ? 1 : 0,
            total: 1
        }
        : null;
    return {
        runs: [__assign({}, run)],
        summary: summary
    };
};
exports.createRunFromJob = function (job) {
    var formattedSteps = job.steps.map(function (step) { return exports.formatStep(step); });
    return {
        status: "queued",
        startTime: new Date(),
        steps: formattedSteps,
        name: job.name
    };
};
exports.formatStep = function (step) {
    var stepAction = step.type === "type" ? "enter" : "click";
    var stepValue = step.value ? step.value + " into " : "";
    var targetTagName = step.locator.inputType
        ? step.locator.tagName + "[type='" + step.locator.inputType + "']"
        : "" + (step.locator.tagName === "a" ? "link" : step.locator.tagName || "");
    var label = step.locator.labels ? step.locator.labels[0] : "";
    var targetName = step.locator.textContent ||
        label ||
        step.locator.name ||
        step.locator.placeholder ||
        step.locator.id ||
        "";
    var name = stepAction + " " + stepValue + targetName + " " + targetTagName;
    return {
        name: name,
        status: "queued"
    };
};
exports.renderCli = function (runner) {
    var runs = exports.buildRuns(runner.getRun());
    Runs_1.default(runs);
};
//# sourceMappingURL=cli.js.map