"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var react_1 = __importDefault(require("react"));
var WIDTH = 7;
var formatElapsedTime = function (startTime) {
    var elapsedSeconds = (new Date().getTime() - startTime.getTime()) / 1000;
    if (elapsedSeconds < 60) {
        return elapsedSeconds + "s";
    }
    var elapsedMinutes = Math.floor(elapsedSeconds / 60);
    var remainingSeconds = elapsedSeconds % 60;
    return elapsedMinutes + "m " + remainingSeconds.toFixed(2) + "s";
};
exports.Results = function (_a) {
    var startTime = _a.startTime, summary = _a.summary;
    if (!summary)
        return null;
    return (react_1.default.createElement(ink_1.Box, { flexDirection: "column" },
        "\n",
        react_1.default.createElement(ink_1.Box, { flexDirection: "row" },
            react_1.default.createElement(ink_1.Box, { width: WIDTH },
                react_1.default.createElement(ink_1.Color, { bold: true }, "Tests:")),
            !!summary.fail && react_1.default.createElement(ink_1.Color, { bold: true, red: true }, summary.fail + " failed"),
            !!summary.fail && ", ",
            !!summary.pass && react_1.default.createElement(ink_1.Color, { bold: true, green: true }, summary.pass + " passed"),
            !!summary.pass && ", ", summary.total + " total"),
        react_1.default.createElement(ink_1.Box, { flexDirection: "row" },
            react_1.default.createElement(ink_1.Box, { width: WIDTH },
                react_1.default.createElement(ink_1.Color, { bold: true }, "Time: ")),
            react_1.default.createElement(ink_1.Color, { bold: true }, formatElapsedTime(startTime)))));
};
//# sourceMappingURL=Results.js.map