"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var react_1 = __importDefault(require("react"));
var Steps_1 = require("./Steps");
var getBackgroundForStatus = function (status) {
    if (status === "runs") {
        return {
            bgYellow: true
        };
    }
    if (status === "pass") {
        return {
            bgGreen: true
        };
    }
    return {
        bgRed: true
    };
};
exports.Run = function (_a) {
    var run = _a.run, showSteps = _a.showSteps;
    var name = run.name, status = run.status;
    return (react_1.default.createElement(ink_1.Box, { flexDirection: "column" },
        react_1.default.createElement(ink_1.Box, null,
            react_1.default.createElement(ink_1.Color, __assign({ bold: true }, getBackgroundForStatus(status), { whiteBright: true }), " " + status.toUpperCase() + " "),
            react_1.default.createElement(ink_1.Box, { marginLeft: 1 },
                react_1.default.createElement(ink_1.Color, { bold: true }, name))),
        !!showSteps && react_1.default.createElement(Steps_1.Steps, { steps: run.steps })));
};
//# sourceMappingURL=Run.js.map