"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var react_1 = __importDefault(require("react"));
var getColorForStatus = function (status) {
    if (status === "pass") {
        return { green: true };
    }
    if (status === "fail" || status === "unreached") {
        return { red: true };
    }
    return {};
};
var getEmojiForStatus = function (status) {
    if (status === "pass") {
        return "✓  ";
    }
    if (status === "fail" || status === "unreached") {
        return "✕  ";
    }
    if (status === "queued") {
        return "   ";
    }
    return "🐺 ";
};
exports.Steps = function (_a) {
    var steps = _a.steps;
    var stepsHtml = steps.map(function (step, i) {
        var name = step.name, status = step.status;
        return (react_1.default.createElement(ink_1.Box, { key: i },
            react_1.default.createElement(ink_1.Color, __assign({}, getColorForStatus(status)), getEmojiForStatus(status)),
            react_1.default.createElement(ink_1.Color, { dim: status === "queued", strikethrough: status === "unreached" }, name)));
    });
    return (react_1.default.createElement(ink_1.Box, { flexDirection: "column", marginLeft: 7 }, stepsHtml));
};
//# sourceMappingURL=Steps.js.map