"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.click = function (element) {
    var clickableElement = findClickableAncestor(element);
    var eventOptions = { bubbles: true };
    clickableElement.dispatchEvent(new MouseEvent("mousedown", eventOptions));
    clickableElement.dispatchEvent(new MouseEvent("mouseup", eventOptions));
    clickableElement.dispatchEvent(new MouseEvent("click", eventOptions));
};
var findClickableAncestor = function (element) {
    if (element.click)
        return element;
    if (!element.parentElement) {
        throw "Element " + element + " does not have parent";
    }
    return findClickableAncestor(element.parentElement);
};
exports.setInputValue = function (element, value) {
    if (value === void 0) { value = null; }
    element.value = value || "";
};
//# sourceMappingURL=actions.js.map